"""
@author: luojunhui
"""
import time
import json
from aliyun.log import LogClient, PutLogsRequest, LogItem


class AliyunArticleLog(object):
    """
    Aliyun 长文日志
    """
    def __init__(self, request_id, alg):
        self.request_id = request_id
        self.alg = alg

    def log(self, code, mode="prod", msg=None, data=None):
        """
        :param mode: 生产环境：prod， 测试环境： dev
        :param code: 状态码
        :param msg: 消息
        :param data: json
        """
        if data is None:
            data = {}
        accessKeyId = "LTAIP6x1l3DXfSxm"
        accessKey = "KbTaM9ars4OX3PMS6Xm7rtxGr1FLon"
        project = "changwen-alg"
        log_store = "long_articles_algorithm"
        endpoint = "cn-hangzhou.log.aliyuncs.com"

        # 创建 LogClient 实例
        client = LogClient(endpoint, accessKeyId, accessKey)
        log_group = []
        log_item = LogItem()
        contents = [
            (f"mode", str(mode)),
            (f"code", str(code)),
            (f"alg", str(self.alg)),
            (f"msg", str(msg)),
            (f"data", json.dumps(data, ensure_ascii=False) if data else ""),
            (f"request_id", str(self.request_id)),
            ("timestamp", str(int(time.time()))),
        ]

        log_item.set_contents(contents)
        log_group.append(log_item)
        # 写入日志
        request = PutLogsRequest(
            project=project,
            logstore=log_store,
            topic="",
            source="",
            logitems=log_group,
            compress=False,
        )
        try:
            client.put_logs(request)
        except Exception as e:
            print("日志失败")
            # print(e)



